=== debian/changelog ===
libavif (1.0.4-1ubuntu3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 07:44:03 +0000

libavif (1.0.4-1ubuntu2) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 07:02:37 +0000

libavif (1.0.4-1ubuntu1) noble; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Disable pandoc and rav1e on i386

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 16 Feb 2024 14:04:18 +0100

libavif (1.0.4-1) unstable; urgency=medium

  * New upstream release.
  * debian/control: Correctly enable libgav1 support on loong64.

 -- Boyuan Yang <byang@debian.org>  Thu, 15 Feb 2024 23:02:10 -0500

libavif (1.0.3-1ubuntu1) noble; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Disable pandoc and rav1e on i386

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 13 Dec 2023 08:31:59 +0100

libavif (1.0.3-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Tue, 12 Dec 2023 16:05:28 -0500

libavif (1.0.2-1ubuntu1) noble; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Disable pandoc and rav1e on i386

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 20 Nov 2023 09:30:32 +0100

libavif (1.0.2-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Sat, 18 Nov 2023 16:03:40 -0500

libavif (1.0.1-2ubuntu4) noble; urgency=medium

  * Rebuild against new libdav1d7.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 07 Nov 2023 09:20:43 +0100

libavif (1.0.1-2ubuntu3) noble; urgency=medium

  * Rebuild against new libsvtav1enc1d1.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 28 Oct 2023 08:23:07 +0200

libavif (1.0.1-2ubuntu2) noble; urgency=medium

  * Also disable pandoc on i386
  * Also disable rav1e on i386

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 27 Oct 2023 07:59:36 +0200

libavif (1.0.1-2) unstable; urgency=medium

  * debian/control,debian/rules: Adjust build-dep architecture requirement:
    + Add loong64 for libgav1-dev.
    + Add riscv64 loong64 for librav1e-dev.
    + Add loong64 for librav1e-dev.
    + Disable hppa hurd-i386 loong64 sparc64 for pandoc.
  * debian/rules: Use prebuilt man pages when pandoc is disabled.
    If pandoc is disabled in debian/control, use prebuilt copied
    located at debian/avifenc.1 and debian/avifdec.1.
    (Closes: #1053179)

 -- Boyuan Yang <byang@debian.org>  Wed, 11 Oct 2023 19:30:04 -0400

libavif (1.0.1-1) unstable; urgency=medium

  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Sat, 07 Oct 2023 14:38:13 -0400

libavif (1.0.1-1~exp2) experimental; urgency=medium

  * debian/control: Add new build-dependency libsharpyuv-dev 
    for sharpyuv support.

 -- Boyuan Yang <byang@debian.org>  Wed, 20 Sep 2023 14:54:19 -0400

libavif (1.0.1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Package rename due to SONAME bump: libavif15 -> libavif16.
  * debian/copyright: Update information.

 -- Boyuan Yang <byang@debian.org>  Sun, 03 Sep 2023 12:48:32 -0400
