## libavif 1.1.0

=== debian/changelog ===
libavif (1.1.0-3ubuntu1) oracular; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Disable pandoc and rav1e on i386

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 19 Jul 2024 19:39:16 +0200

libavif (1.1.0-3) unstable; urgency=high

  * debian/control: Manually record dependency to various dev packages
    for libavif-dev: libaom-dev, libdav1d-dev, librav1e-dev (some archs),
    libsvtav1enc-dev, libyuv-dev. (Closes: #1076509)

 -- Boyuan Yang <byang@debian.org>  Fri, 19 Jul 2024 12:25:37 -0400

libavif (1.1.0-2ubuntu2) oracular; urgency=medium

  * Add runtime dependencies to libdav1d-dev librav1e-dev libaom-dev libsvtav1enc-dev
    to help xpra building correctly (Closes: #1076509)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 17 Jul 2024 19:00:28 +0200

libavif (1.1.0-2ubuntu1) oracular; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Disable pandoc and rav1e on i386

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 16 Jul 2024 10:35:41 +0200

libavif (1.1.0-2) unstable; urgency=medium

  * Enable SVT-AV1 support unconditionally now that SVT-AV1 is available
    on all official architectures. Thanks to Adrian Bunk.

 -- Boyuan Yang <byang@debian.org>  Mon, 15 Jul 2024 10:32:23 -0400

libavif (1.1.0-1) unstable; urgency=medium

  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Mon, 15 Jul 2024 08:20:39 -0400

libavif (1.1.0-1~exp1) experimental; urgency=medium

  * New upstream release.
  * debian/rules: Force using system libyuv instead of the embedded copy.
  * debian/rules: Update buildflags to fix the deprecation warnings.
  * debian/rules: Correctly enable rav1e on riscv64.
  * debian/copyright: Updated.

 -- Boyuan Yang <byang@debian.org>  Sat, 13 Jul 2024 13:43:12 -0400

libavif (1.0.4-3ubuntu2) oracular; urgency=medium

  * Rebuild against new libsvtav1enc2.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 10 Jul 2024 16:41:04 +0200

libavif (1.0.4-3ubuntu1) oracular; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Disable pandoc and rav1e on i386

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 16 May 2024 08:05:43 +0200

libavif (1.0.4-3) unstable; urgency=medium

  * Team upload
  * debian/: Restrict use of libgav1 to little-endian architectures (Closes:
    #1070645)

 -- Sebastian Ramacher <sramacher@debian.org>  Thu, 09 May 2024 18:57:01 +0200

libavif (1.0.4-2ubuntu1) oracular; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Disable pandoc and rav1e on i386

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 04 May 2024 09:30:51 +0200

libavif (1.0.4-2) unstable; urgency=medium

  * Team upload
  * debian/control: Use pkgconf
  * debian/: Temporarily disable libgav1 support on s390x
    libgav1 currently FTBFS on s390x.

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 07 Apr 2024 15:49:47 +0200
